=== source/CMakeLists.txt ===
--- 
+++ 
@@ -28,10 +28,10 @@
 option(FPROFILE_GENERATE "Compile executable to generate usage data" OFF)
 option(FPROFILE_USE "Compile executable using generated usage data" OFF)
 option(NATIVE_BUILD "Target the build CPU" OFF)
-option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
+option(STATIC_LINK_CRT "Statically link C and C++ runtimes for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 212)
+set(X265_BUILD 215)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -87,11 +87,28 @@
 
     option(AARCH64_WARNINGS_AS_ERRORS "Build with -Werror for AArch64 Intrinsics files" OFF)
 
-    # Options for cross compiling AArch64 optional extensions
-    option(CROSS_COMPILE_SVE "Cross Compile for SVE Target" OFF)
-    option(CROSS_COMPILE_SVE2 "Cross Compile for SVE2 Target" OFF)
-    option(CROSS_COMPILE_NEON_DOTPROD "Cross Compile for Neon DotProd Target" OFF)
-    option(CROSS_COMPILE_NEON_I8MM "Cross Compile for Neon I8MM Target" OFF)
+    option(AARCH64_RUNTIME_CPU_DETECT "Enable AArch64 run-time CPU feature detection" ON)
+    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin|Windows")
+        set(AARCH64_RUNTIME_CPU_DETECT OFF CACHE BOOL "" FORCE)
+        message(STATUS "Run-time CPU feature detection unsupported on this platform")
+    endif()
+
+    # Options for manually enabling/disabling AArch64 SIMD extensions.
+    option(ENABLE_NEON "Enable Neon" ON)
+    option(ENABLE_NEON_DOTPROD "Enable Neon DotProd" ON)
+    option(ENABLE_NEON_I8MM "Enable Neon I8MM" ON)
+    option(ENABLE_SVE "Enable SVE" ON)
+    option(ENABLE_SVE2 "Enable SVE2" ON)
+
+    # Compiler flags for AArch64 extensions.
+    set(AARCH64_NEON_FLAG "-march=armv8-a")
+    # Neon DotProd is mandatory from Armv8.4.
+    set(AARCH64_NEON_DOTPROD_FLAG "-march=armv8.2-a+dotprod")
+    # Neon I8MM is mandatory from Armv8.6.
+    set(AARCH64_NEON_I8MM_FLAG "-march=armv8.2-a+dotprod+i8mm")
+    set(AARCH64_SVE_FLAG "-march=armv8.2-a+dotprod+i8mm+sve")
+    # SVE2 is only available from Armv9.0, and armv9-a implies +dotprod and +sve.
+    set(AARCH64_SVE2_FLAG "-march=armv9-a+i8mm+sve2")
 else()
     message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
     message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
@@ -137,11 +154,11 @@
     endif()
 endif(UNIX)
 
-if(X64 AND NOT WIN32)
+if((X64 AND NOT WIN32) OR ARM64)
     option(ENABLE_PIC "Enable Position Independent Code" ON)
 else()
     option(ENABLE_PIC "Enable Position Independent Code" OFF)
-endif(X64 AND NOT WIN32)
+endif()
 
 # Compiler detection
 if(CMAKE_GENERATOR STREQUAL "Xcode")
@@ -264,34 +281,20 @@
         endif()
     endif()
     if(ARM64)
-        message(STATUS "Found Neon")
         set(CPU_HAS_NEON 1)
-        add_definitions(-DX265_ARCH_ARM64=1 -DHAVE_NEON=1)
-
-        if(CROSS_COMPILE_ARM64)
-            # Handle cross-compilation options.
-            if(CROSS_COMPILE_NEON_DOTPROD)
-                set(CPU_HAS_NEON_DOTPROD 1)
-            endif()
-            if(CROSS_COMPILE_NEON_I8MM)
-                set(CPU_HAS_NEON_I8MM 1)
-                # Impose the constraint that Neon I8MM implies Neon DotProd.
-                set(CPU_HAS_NEON_DOTPROD 1)
-            endif()
-            if(CROSS_COMPILE_SVE)
-                set(CPU_HAS_SVE 1)
-                # Impose the constraint that SVE implies Neon DotProd and I8MM.
-                set(CPU_HAS_NEON_DOTPROD 1)
-                set(CPU_HAS_NEON_I8MM 1)
-            endif()
-            if(CROSS_COMPILE_SVE2)
-                set(CPU_HAS_SVE2 1)
-                # SVE2 implies SVE and Neon DotProd.
-                set(CPU_HAS_SVE 1)
-                set(CPU_HAS_NEON_DOTPROD 1)
-                # Impose the constraint that SVE2 implies Neon I8MM.
-                set(CPU_HAS_NEON_I8MM 1)
-            endif()
+        add_definitions(-DX265_ARCH_ARM64=1)
+
+        if (AARCH64_RUNTIME_CPU_DETECT)
+            add_definitions(-DAARCH64_RUNTIME_CPU_DETECT=1)
+            message(STATUS "Configuring build for run-time CPU feature detection")
+        endif()
+
+        if(AARCH64_RUNTIME_CPU_DETECT OR CROSS_COMPILE_ARM64)
+            # Add all extensions when compiling for run-time CPU feature detection or cross compiling.
+            set(CPU_HAS_NEON_DOTPROD 1)
+            set(CPU_HAS_NEON_I8MM 1)
+            set(CPU_HAS_SVE 1)
+            set(CPU_HAS_SVE2 1)
         else()
             if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
                 find_package(NEON_DOTPROD)
@@ -299,30 +302,28 @@
                 find_package(SVE)
                 find_package(SVE2)
             else()
-                message(STATUS "Compile time feature detection unsupported on this platform")
+                message(STATUS "Compile-time CPU feature detection unsupported on this platform")
             endif()
         endif()
 
-        if(CPU_HAS_NEON_DOTPROD)
-            # Neon DotProd is mandatory from Armv8.4.
-            message(STATUS "Found Neon DotProd")
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod)
-            add_definitions(-DHAVE_NEON_DOTPROD=1)
-        endif()
-        if(CPU_HAS_NEON_I8MM)
-            # Neon I8MM is mandatory from Armv8.6.
-            message(STATUS "Found Neon I8MM")
-            # Impose the constraint that Neon I8MM implies Neon DotProd.
-            if(NOT CPU_HAS_NEON_DOTPROD)
-                message(FATAL_ERROR "Unsupported AArch64 feature combination (Neon I8MM without Neon DotProd)")
-            endif()
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm)
-            add_definitions(-DHAVE_NEON_I8MM=1)
-        endif()
-        if(CPU_HAS_SVE)
-            message(STATUS "Found SVE")
-            # Impose the constraint that SVE implies Neon I8MM.
-            if(NOT CPU_HAS_NEON_I8MM)
-                message(FATAL_ERROR "Unsupported AArch64 feature combination (SVE without Neon I8MM)")
-            endif()
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm+sve)
+        if(ENABLE_SVE OR ENABLE_SVE2)
+            set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
+            string(APPEND CMAKE_REQUIRED_FLAGS " ${AARCH64_SVE_FLAG}")
+            set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
+            set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
+
+            # Check whether the compiler can compile SVE functions that require
+            # backup/restore of SVE registers according to AAPCS.
+            # https://github.com/llvm/llvm-project/issues/80009.
+            set(SVE_COMPILATION_TEST "
+#include <arm_sve.h>
+void other();
+svfloat32_t func(svfloat32_t a) {
+  other();
+  return a;
+}
+int main() { return 0; }")
+
+            check_c_source_compiles("${SVE_COMPILATION_TEST}" SVE_COMPILATION_C_TEST_COMPILED)
+            check_cxx_source_compiles("${SVE_COMPILATION_TEST}" SVE_COMPILATION_CXX_TEST_COMPILED)
+
