=== source/profile/PPA/CMakeLists.txt ===
add_library(PPA ppa.h ppaApi.h ppa.cpp ../cpuEvents.h)
