=== debian/changelog ===
x265 (4.1-3) unstable; urgency=medium

  * debian/control:
   - Bump Standards-Version
   - Remove mips* handling
  * debian/patches: Fix FTBFS with cmake 4 (Closes: #1113635)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 10:59:30 +0200

x265 (4.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 22 Jan 2025 01:55:30 +0100

x265 (4.1-1) experimental; urgency=medium

  * New upstream version 4.1
  * SONAME bump: libx265-209 -> libx256-215
  * debian/patches: Refresh patches
  * debian/copyright: Update copyright years
  * debian/control: Add python3-sphinx-rtd-theme to Build-Depends-Indep

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 15 Jan 2025 21:28:29 +0100
