=== debian/watch ===
version=4
https://bitbucket.org/multicoreware/x265_git/downloads/ \
  x265_(\d.*).tar.gz
